# ‐*‐coding:utf‐8 ‐*‐ #
# ‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐
# ProjectName: program01
# FileName: requests_method.py
# Author: Conner-Lee
# Datetime: 2024/11/9 11:42
# Description: 
# ‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐
import requests.sessions

from ApiAutoTest import log
from ApiAutoTest.common.db import DB
from ApiAutoTest.common.read_basic_ini import ReadBasicIni


class RequestsMethod:

    def __init__(self):
        # 关联登录状态
        self.db = DB()
        self.session = requests.sessions.Session()
        login_url = ReadBasicIni().get_host("bpm") + "/auth"
        login_data = {"username": "admin", "password": "QKpkgIwnyACrUXQrQVRaSUbhPSOsKnj5hoRN5LGKH"
                                                       "T3NmLCwGIN+aGa981YZtlLoEfpVvGDnILn0QU09VHSkgL+Or6"
                                                       "oTG1E8OtVTmAEjivAe/a4zLPwd/OfvKYIYbBP5ExZyy+wlVTbLgDfqkuK"
                                                       "PGOMPPSLlZWLfvG7yzdc+CyE="}
        res = self.session.post(login_url, json=login_data)
        token = res.json().get("token")
        self.session.headers.update({"Authorization": f"Bearer {token}"})

    @log
    def request_all(self, method, url, mime=None, case_data=None, sql_type=None, sql_data=None, update_key=None):
        if sql_type == "delete":
            self.db.delete(sql_data)
        elif sql_type == "select":
            select_result = self.db.select(sql_data)
            case_data[update_key] = select_result
        elif sql_type == "select|delete" or sql_type == "delete|select":
            # 执行删除语句
            self.db.delete(sql_data["delete"])
            # 执行查询语句
            select_result = self.db.select(sql_data["select"])
            case_data[update_key] = select_result

        # 根据请求的媒体类型发送请求
        # 发送的数据为json数据
        if mime == "json" or mime == "application/json":
            return self.session.request(method, url, json=case_data)
        # 发送的数据为文件
        elif mime == "multipart/form-data" or mime == "form-data":
            return self.session.request(method, url, files=case_data)
        # 通过URL传参
        elif mime == "query":
            return self.session.request(method, url, params=case_data)
        # 不传参
        elif mime is None:
            return self.session.request(method, url)
        # 需要同时传参
        elif mime == "query|json" or mime == "json|query":
            return self.session.request(method, url, json=case_data, params=case_data)
        # 都不是，抛出错误
        else:
            raise ValueError(f"方法：request_all，传入的媒体类型为：{mime}, 没有符合的判断分支，可以自行封装，也可以继承之后覆盖")
