# ‐*‐coding:utf‐8 ‐*‐ #
# ‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐
# ProjectName: program01
# FileName: conftest.py
# Author: Conner-Lee
# Datetime: 2024/11/9 14:26
# Description: 这个文件解决用例中文显示问题
# ‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐‐

def pytest_collection_modifyitems(items):
    """
    一个 hook 函数，用于在测试收集完成后对测试项进行修改

    · encode("utf-8")：将字符串转换为字节序列。
    · decode("unicode-escape")：将字节序列解码为字符串，并解析其中的 Unicode 转义序列。

    · item.name：测试项的名称，通常是测试函数的名称。
    · item._nodeid：测试项的唯一标识符，通常包括测试文件路径和测试函数的名称。

    :param items: 所有的测试项
    :return:
    """
    for item in items:
        item.name = item.name.encode("utf-8").decode("unicode-escape")
        item._nodeid = item._nodeid.encode("utf-8").decode("unicode-escape")